// ----------------------------------------------------------------------------
//
// VDream Component Suite version 5.0
//
// http://www.vdream.co.kr
//
// Copyright (c) NetworkLab Corporation All rights reserved
//
// ----------------------------------------------------------------------------

#ifndef __SIPPARSER_H__
#define __SIPPARSER_H__

#include "VDCommon.h"
#include "VDList.h"
#include "VDNet.h"
#include "SnoopType.h"

// ----------------------------------------------------------------------------
// SIPConnect
// ----------------------------------------------------------------------------
class SIPConnect
{
public:
  IP  ip;
  int port;
public:
  SIPConnect()          { ip = 0; port = 0; }
  virtual ~SIPConnect() {}
};

// ----------------------------------------------------------------------------
// SIPConnectList
// ----------------------------------------------------------------------------
class SIPConnectList : public VDPList<SIPConnect*>
{
public:
  SIPConnectList();
  virtual ~SIPConnectList();
public:
  bool        exists(IP ip, int port);
  SIPConnect* add(IP ip, int port);
  void addConnectList(SIPConnectList* src);
  void logConnectList();
};

// ----------------------------------------------------------------------------
// SIPParser
// ----------------------------------------------------------------------------
class SIPParser
{
public:
  string from;
  string to;
  string cseq_method;
  SIPConnectList connectList;
public:
  SIPParser();
  virtual ~SIPParser();
public:
  bool parse(char* buf, int len);
protected:
  bool parseSDP(void* _sdp); // sdp_message_t* sdp
};

#endif  __SIPPARSER_H__

