#include "VSAddr.h"

// ----------------------------------------------------------------------------
// VSAddr
// ----------------------------------------------------------------------------
void VSAddr::clear()
{
  ip = 0;
  port = 0;
}

VSAddr& VSAddr::operator = (VSAddr& rhs)
{
  ip = rhs.ip;
  port = rhs.port;
  return *this;
};

bool VSAddr::operator == (VSAddr& rhs)
{
  if (ip != rhs.ip) return false;
  if (port != rhs.port) return false;
  return true;
}

bool VSAddr::operator != (VSAddr& rhs)
{
  return !(*this == rhs);
}

string VSAddr::str()
{
  return ip_to_str(ip) + "(" + int_to_str(port) + ")";
}

// ----------------------------------------------------------------------------
// VSAddrList
// ----------------------------------------------------------------------------
VSAddr* VSAddrList::find(IP ip, int port)
{
  for (int i= 0; i < count(); i++)
  {
    VSAddr* voipAddr = at(i);
    if (voipAddr->ip == ip && voipAddr->port == port) return voipAddr;
  }
  return NULL;
}
