// ----------------------------------------------------------------------------
//
// VoIPSniffer version 2.0
//
// http://www.gilgil.net
//
// Copyright (c) NetworkLab Corporation All rights reserved
//
// ----------------------------------------------------------------------------

#ifndef __VSCALL_H__
#define __VSCALL_H__

#include "VSCommon.h"
#include "time.h" // for localtime

// ----------------------------------------------------------------------------
// VSCall
// ----------------------------------------------------------------------------
class VSCall
{
public:
  bool     active;
public:
  VSCall();
  virtual ~VSCall();

public:
  string from;
  string to;
  VSAddr fromAddr;
  VSAddr toAddr;
  bool   callInfoVerified;

public:
	struct timeval begin_tv;
  struct timeval end_tv;
  struct tm      begin_tm;
  struct tm      end_tm;
public:
  void setBeginTime(struct timeval* tv);
  void setEndTime  (struct timeval * tv);

public:
  int             packetCount;
  DWORD           lastAccessTick;
  VSSessionList*  sessionList;
  SIPConnectList* fromConnectList;
  SIPConnectList* toConnectList;
  SIPConnectList* unknownConnectList;

public:
  virtual bool open();
  virtual bool close();
  virtual void changeCallInfo(string from, string to, VSAddr* fromAddr, VSAddr* toAddr);
  virtual void processPacket(SnoopIPPacket* packet);
};

// ----------------------------------------------------------------------------
// VSCallList
// ----------------------------------------------------------------------------
class VSCallList : public VDPList<VSCall*>
{
public:
  VSCallList();
  virtual ~VSCallList();
  bool open();
  bool close();

public:
  VSCall*    findCall(VSAddr* fromAddr, VSAddr* toAddr);
  VSSession* findSession(VSAddr* srcMAddr, VSAddr*dstMAddr);

protected:
  void getCallListByMediaAddr(VSAddr* mAddr, VSCallList* outCallList);
  void getDupCallList(VSCallList* callList1, VSCallList* callList2, VSCallList* outCallList);

public:
  VSCall* findCallByMediaAddr(VSAddr* mAddr1, VSAddr* mAddr2); // called in VSSessionMgr
  VSCall* findCallByConnectInfo(SIPConnect* connect); // called in VSCallMsg
};

// ----------------------------------------------------------------------------
// VSCallMgr
// ----------------------------------------------------------------------------
class VSCallMgr : public VSCallList
{
public:
  static bool process(
    VSSniff*       sniff,
    SnoopIPPacket* packet,
    VSAddr*        srcAddr,
    VSAddr*        dstAddr,
    char*          data,
    int            dataLen);
};


#endif  __VSCALL_H__
