#include "VSCodecG711.h"

// ----------------------------------------------------------------------------
// VSCodecG711
// ----------------------------------------------------------------------------
VSCodecG711::VSCodecG711()
{
  VSG72XDLL::classInitialize();
  encHandle = g711_enc_create();
  decHandle = g711_dec_create();
}

VSCodecG711::~VSCodecG711()
{
  close();
  if (encHandle != 0)
  {
    g711_enc_delete(encHandle);
    encHandle = 0;
  }
  if (decHandle != 0)
  {
    g711_enc_delete(decHandle);
    decHandle = 0;
  }
  VSG72XDLL::classFinalize();
}

bool VSCodecG711::open()
{
  if (!g711_enc_open(encHandle)) goto _error;
  if (!g711_dec_open(decHandle)) goto _error;
  return true;
_error:
  close();
  return false;
}

bool VSCodecG711::close()
{
  bool res = true;
  if (!g711_enc_close(encHandle)) res = false;
  if (!g711_dec_close(decHandle)) res = false;
  return res;
}

int VSCodecG711::encode(char* bit, int bitSize, char* pcm, int pcmSize)
{
  return g711_enc_encode(encHandle, bit, bitSize, pcm, pcmSize);
}

int VSCodecG711::decode(char* pcm, int pcmSize, char* bit, int bitSize)
{
  return g711_dec_decode(decHandle, pcm, pcmSize, bit, bitSize);
}
