#include "VSCodecG723.h"

// ----------------------------------------------------------------------------
// VSCodecG723
// ----------------------------------------------------------------------------
VSCodecG723::VSCodecG723()
{
  VSG72XDLL::classInitialize();
  encHandle = g723_enc_create();
  decHandle = g723_dec_create();
}

VSCodecG723::~VSCodecG723()
{
  close();
  if (encHandle != 0)
  {
    g723_enc_delete(encHandle);
    encHandle = 0;
  }
  if (decHandle != 0)
  {
    g723_enc_delete(decHandle);
    decHandle = 0;
  }
  VSG72XDLL::classFinalize();
}

bool VSCodecG723::open()
{
  if (!g723_enc_open(encHandle)) goto _error;
  if (!g723_dec_open(decHandle)) goto _error;
  return true;
_error:
  close();
  return false;
}

bool VSCodecG723::close()
{
  bool res = true;
  if (!g723_enc_close(encHandle)) res = false;
  if (!g723_dec_close(decHandle)) res = false;
  return res;
}

int VSCodecG723::encode(char* bit, int bitSize, char* pcm, int pcmSize)
{
  return g723_enc_encode(encHandle, bit, bitSize, pcm, pcmSize);
}

int VSCodecG723::decode(char* pcm, int pcmSize, char* bit, int bitSize)
{
  return g723_dec_decode(decHandle, pcm, pcmSize, bit, bitSize);
}
