#include "VSCodecG729.h"

// ----------------------------------------------------------------------------
// VSCodecG729
// ----------------------------------------------------------------------------
VSCodecG729::VSCodecG729()
{
  VSG72XDLL::classInitialize();
  encHandle = g729_enc_create();
  decHandle = g729_dec_create();
}

VSCodecG729::~VSCodecG729()
{
  close();
  if (encHandle != 0)
  {
    g729_enc_delete(encHandle);
    encHandle = 0;
  }
  if (decHandle != 0)
  {
    g729_enc_delete(decHandle);
    decHandle = 0;
  }
  VSG72XDLL::classFinalize();
}

bool VSCodecG729::open()
{
  if (!g729_enc_open(encHandle)) goto _error;
  if (!g729_dec_open(decHandle)) goto _error;
  return true;
_error:
  close();
  return false;
}

bool VSCodecG729::close()
{
  bool res = true;
  if (!g729_enc_close(encHandle)) res = false;
  if (!g729_dec_close(decHandle)) res = false;
  return res;
}

int VSCodecG729::encode(char* bit, int bitSize, char* pcm, int pcmSize)
{
  return g729_enc_encode(encHandle, bit, bitSize, pcm, pcmSize);
}

int VSCodecG729::decode(char* pcm, int pcmSize, char* bit, int bitSize)
{
  return g729_dec_decode(decHandle, pcm, pcmSize, bit, bitSize);
}
