#include "VSG72X.h"

// ----------------------------------------------------------------------------
// VSG72XDLL
// ----------------------------------------------------------------------------
bool VSG72XDLL::load()
{
  g711_enc_create    = (HANDLE (*) ())                                                              GetProcAddress(dllHandle, _T("g711_enc_create"));
  if (g711_enc_create    == NULL) goto _error;
  g711_enc_delete    = (void   (*) (HANDLE handle))                                                 GetProcAddress(dllHandle, _T("g711_enc_delete"));
  if (g711_enc_delete    == NULL) goto _error;
  g711_enc_open      = (bool   (*) (HANDLE handle))                                                 GetProcAddress(dllHandle, _T("g711_enc_open"));
  if (g711_enc_open      == NULL) goto _error;
  g711_enc_close     = (bool   (*) (HANDLE handle))                                                 GetProcAddress(dllHandle, _T("g711_enc_close"));
  if (g711_enc_close     == NULL) goto _error;
  g711_enc_encode    = (int    (*) (HANDLE handle, char* bit, int bitSize, char *pcm, int pcmSize)) GetProcAddress(dllHandle, _T("g711_enc_encode"));
  if (g711_enc_encode    == NULL) goto _error;
  g711_enc_get_option= (int    (*) (HANDLE handle, int option))                                     GetProcAddress(dllHandle, _T("g711_enc_get_option"));
  if (g711_enc_get_option== NULL) goto _error;
  g711_enc_set_option= (void   (*) (HANDLE handle, int option, int value))                          GetProcAddress(dllHandle, _T("g711_enc_set_option"));
  if (g711_enc_set_option== NULL) goto _error;

  g711_dec_create    = (HANDLE (*) ())                                                              GetProcAddress(dllHandle, _T("g711_dec_create"));
  if (g711_dec_create    == NULL) goto _error; 
  g711_dec_delete    = (void   (*) (HANDLE handle))                                                 GetProcAddress(dllHandle, _T("g711_dec_delete"));
  if (g711_dec_delete    == NULL) goto _error;
  g711_dec_open      = (bool   (*) (HANDLE handle))                                                 GetProcAddress(dllHandle, _T("g711_dec_open"));
  if (g711_dec_open      == NULL) goto _error;
  g711_dec_close     = (bool   (*) (HANDLE handle))                                                 GetProcAddress(dllHandle, _T("g711_dec_close"));
  if (g711_dec_close     == NULL) goto _error;
  g711_dec_decode    = (int    (*) (HANDLE handle, char *pcm, int pcmSize, char* bit, int bitSize)) GetProcAddress(dllHandle, _T("g711_dec_decode"));
  if (g711_dec_decode    == NULL) goto _error;
  g711_dec_get_option= (int    (*) (HANDLE handle, int option))                                     GetProcAddress(dllHandle, _T("g711_dec_get_option"));
  if (g711_dec_get_option== NULL) goto _error;
  g711_dec_set_option= (void   (*) (HANDLE handle, int option, int value))                          GetProcAddress(dllHandle, _T("g711_dec_set_option"));
  if (g711_dec_set_option== NULL) goto _error;

  g723_enc_create    = (HANDLE (*) ())                                                              GetProcAddress(dllHandle, _T("g723_enc_create"));
  if (g723_enc_create    == NULL) goto _error;
  g723_enc_delete    = (void   (*) (HANDLE handle))                                                 GetProcAddress(dllHandle, _T("g723_enc_delete"));
  if (g723_enc_delete    == NULL) goto _error;
  g723_enc_open      = (bool   (*) (HANDLE handle))                                                 GetProcAddress(dllHandle, _T("g723_enc_open"));
  if (g723_enc_open      == NULL) goto _error;
  g723_enc_close     = (bool   (*) (HANDLE handle))                                                 GetProcAddress(dllHandle, _T("g723_enc_close"));
  if (g723_enc_close     == NULL) goto _error;
  g723_enc_encode    = (int    (*) (HANDLE handle, char* bit, int bitSize, char *pcm, int pcmSize)) GetProcAddress(dllHandle, _T("g723_enc_encode"));
  if (g723_enc_encode    == NULL) goto _error;
  g723_enc_get_option= (int    (*) (HANDLE handle, int option))                                     GetProcAddress(dllHandle, _T("g723_enc_get_option"));
  if (g723_enc_get_option== NULL) goto _error;
  g723_enc_set_option= (void   (*) (HANDLE handle, int option, int value))                          GetProcAddress(dllHandle, _T("g723_enc_set_option"));
  if (g723_enc_set_option== NULL) goto _error;

  g723_dec_create    = (HANDLE (*) ())                                                              GetProcAddress(dllHandle, _T("g723_dec_create"));
  if (g723_dec_create    == NULL) goto _error;
  g723_dec_delete    = (void   (*) (HANDLE handle))                                                 GetProcAddress(dllHandle, _T("g723_dec_delete"));
  if (g723_dec_delete    == NULL) goto _error;
  g723_dec_open      = (bool   (*) (HANDLE handle))                                                 GetProcAddress(dllHandle, _T("g723_dec_open"));
  if (g723_dec_open      == NULL) goto _error;
  g723_dec_close     = (bool   (*) (HANDLE handle))                                                 GetProcAddress(dllHandle, _T("g723_dec_close"));
  if (g723_dec_close     == NULL) goto _error;
  g723_dec_decode    = (int    (*) (HANDLE handle, char *pcm, int pcmSize, char* bit, int bitSize)) GetProcAddress(dllHandle, _T("g723_dec_decode"));
  if (g723_dec_decode    == NULL) goto _error;
  g723_dec_get_option= (int    (*) (HANDLE handle, int option))                                     GetProcAddress(dllHandle, _T("g723_dec_get_option"));
  if (g723_dec_get_option== NULL) goto _error;
  g723_dec_set_option= (void   (*) (HANDLE handle, int option, int value))                          GetProcAddress(dllHandle, _T("g723_dec_set_option"));
  if (g723_dec_set_option== NULL) goto _error;

  g729_enc_create    = (HANDLE (*) ())                                                              GetProcAddress(dllHandle, _T("g729_enc_create"));
  if (g729_enc_create    == NULL) goto _error;
  g729_enc_delete    = (void   (*) (HANDLE handle))                                                 GetProcAddress(dllHandle, _T("g729_enc_delete"));
  if (g729_enc_delete    == NULL) goto _error;
  g729_enc_open      = (bool   (*) (HANDLE handle))                                                 GetProcAddress(dllHandle, _T("g729_enc_open"));
  if (g729_enc_open      == NULL) goto _error;
  g729_enc_close     = (bool   (*) (HANDLE handle))                                                 GetProcAddress(dllHandle, _T("g729_enc_close"));
  if (g729_enc_close     == NULL) goto _error;
  g729_enc_encode    = (int    (*) (HANDLE handle, char* bit, int bitSize, char *pcm, int pcmSize)) GetProcAddress(dllHandle, _T("g729_enc_encode"));
  if (g729_enc_encode    == NULL) goto _error;
  g729_enc_get_option= (int    (*) (HANDLE handle, int option))                                     GetProcAddress(dllHandle, _T("g729_enc_get_option"));
  if (g729_enc_get_option== NULL) goto _error;
  g729_enc_set_option= (void   (*) (HANDLE handle, int option, int value))                          GetProcAddress(dllHandle, _T("g729_enc_set_option"));
  if (g729_enc_set_option== NULL) goto _error;

  g729_dec_create    = (HANDLE (*) ())                                                              GetProcAddress(dllHandle, _T("g729_dec_create"));
  if (g729_dec_create    == NULL) goto _error;
  g729_dec_delete    = (void   (*) (HANDLE handle))                                                 GetProcAddress(dllHandle, _T("g729_dec_delete"));
  if (g729_dec_delete    == NULL) goto _error;
  g729_dec_open      = (bool   (*) (HANDLE handle))                                                 GetProcAddress(dllHandle, _T("g729_dec_open"));
  if (g729_dec_open      == NULL) goto _error;
  g729_dec_close     = (bool   (*) (HANDLE handle))                                                 GetProcAddress(dllHandle, _T("g729_dec_close"));
  if (g729_dec_close     == NULL) goto _error;
  g729_dec_decode    = (int    (*) (HANDLE handle, char *pcm, int pcmSize, char* bit, int bitSize)) GetProcAddress(dllHandle, _T("g729_dec_decode"));
  if (g729_dec_decode    == NULL) goto _error;
  g729_dec_get_option= (int    (*) (HANDLE handle, int option))                                     GetProcAddress(dllHandle, _T("g729_dec_get_option"));
  if (g729_dec_get_option== NULL) goto _error;
  g729_dec_set_option= (void   (*) (HANDLE handle, int option, int value))                          GetProcAddress(dllHandle, _T("g729_dec_set_option"));
  if (g729_dec_set_option== NULL) goto _error;

  return true;
_error:
  return false;
}

int VSG72XDLL::refCount = 0;
VSG72XDLL* VSG72XDLL::g_g72xDLL = NULL;

void VSG72XDLL::classInitialize()
{
  if (refCount++ != 0) return;

  VDLog::classInitialize();

  g_g72xDLL = new VSG72XDLL;
  g_g72xDLL->addRef();
}

void VSG72XDLL::classFinalize()
{
  if (--refCount != 0) return;

  g_g72xDLL->release();
  SAFE_DELETE(g_g72xDLL);

  VDLog::classFinalize();
}

// ----------------------------------------------------------------------------
// Functions
// ----------------------------------------------------------------------------
HANDLE (*g711_enc_create)    () = NULL;
void   (*g711_enc_delete)    (HANDLE handle) = NULL;
bool   (*g711_enc_open)      (HANDLE handle) = NULL;
bool   (*g711_enc_close)     (HANDLE handle) = NULL;
int    (*g711_enc_encode)    (HANDLE handle, char* bit, int bitSize, char *pcm, int pcmSize) = NULL;
int    (*g711_enc_get_option)(HANDLE handle, int option) = NULL;
void   (*g711_enc_set_option)(HANDLE handle, int option, int value) = NULL;

HANDLE (*g711_dec_create)    () = NULL;
void   (*g711_dec_delete)    (HANDLE handle) = NULL;
bool   (*g711_dec_open)      (HANDLE handle) = NULL;
bool   (*g711_dec_close)     (HANDLE handle) = NULL;
int    (*g711_dec_decode)    (HANDLE handle, char *pcm, int pcmSize, char* bit, int bitSize) = NULL;
int    (*g711_dec_get_option)(HANDLE handle, int option) = NULL;
void   (*g711_dec_set_option)(HANDLE handle, int option, int value) = NULL;

HANDLE (*g723_enc_create)    () = NULL;
void   (*g723_enc_delete)    (HANDLE handle) = NULL;
bool   (*g723_enc_open)      (HANDLE handle) = NULL;
bool   (*g723_enc_close)     (HANDLE handle) = NULL;
int    (*g723_enc_encode)    (HANDLE handle, char* bit, int bitSize, char *pcm, int pcmSize) = NULL;
int    (*g723_enc_get_option)(HANDLE handle, int option) = NULL;
void   (*g723_enc_set_option)(HANDLE handle, int option, int value) = NULL;

HANDLE (*g723_dec_create)    () = NULL;
void   (*g723_dec_delete)    (HANDLE handle) = NULL;
bool   (*g723_dec_open)      (HANDLE handle) = NULL;
bool   (*g723_dec_close)     (HANDLE handle) = NULL;
int    (*g723_dec_decode)    (HANDLE handle, char *pcm, int pcmSize, char* bit, int bitSize) = NULL;
int    (*g723_dec_get_option)(HANDLE handle, int option) = NULL;
void   (*g723_dec_set_option)(HANDLE handle, int option, int value) = NULL;

HANDLE (*g729_enc_create)    () = NULL;
void   (*g729_enc_delete)    (HANDLE handle) = NULL;
bool   (*g729_enc_open)      (HANDLE handle) = NULL;
bool   (*g729_enc_close)     (HANDLE handle) = NULL;
int    (*g729_enc_encode)    (HANDLE handle, char* bit, int bitSize, char *pcm, int pcmSize) = NULL;
int    (*g729_enc_get_option)(HANDLE handle, int option) = NULL;
void   (*g729_enc_set_option)(HANDLE handle, int option, int value) = NULL;

HANDLE (*g729_dec_create)    () = NULL;
void   (*g729_dec_delete)    (HANDLE handle) = NULL;
bool   (*g729_dec_open)      (HANDLE handle) = NULL;
bool   (*g729_dec_close)     (HANDLE handle) = NULL;
int    (*g729_dec_decode)    (HANDLE handle, char *pcm, int pcmSize, char* bit, int bitSize) = NULL;
int    (*g729_dec_get_option)(HANDLE handle, int option) = NULL;
void   (*g729_dec_set_option)(HANDLE handle, int option, int value) = NULL;
