// ----------------------------------------------------------------------------
//
// VoIPSniffer version 2.0
//
// http://www.gilgil.net
//
// Copyright (c) NetworkLab Corporation All rights reserved
//
// ----------------------------------------------------------------------------

#ifndef __VSG72X_H__
#define __VSG72X_H__

#include "VDDLL.h"

// ----------------------------------------------------------------------------
// Buf Size
// ----------------------------------------------------------------------------
#define G711_PCM_BUF_SIZE     160
#define G711_BIT_BUF_SIZE     80

#define G723_PCM_BUF_SIZE     480
#define G723_BIT_BUF_SIZE     24

#define G729_PCM_BUF_SIZE     160
#define G729_BIT_BUF_SIZE     10

// ----------------------------------------------------------------------------
// Option
// ----------------------------------------------------------------------------
#define G711_OPTION_CODECTYPE 0
#define G711_OPTION_MODE      1

#define G723_OPTION_MODE      1
#define G723_OPTION_WORK_RATE 2
#define G723_WORK_RATE_63     0
#define G723_WORK_RATE_53     1

#define G729_OPTION_CODECTYPE 0
#define G729_OPTION_MODE      1

// ----------------------------------------------------------------------------
// g711_enc
// ----------------------------------------------------------------------------
extern HANDLE (*g711_enc_create)    ();
extern void   (*g711_enc_delete)    (HANDLE handle);
extern bool   (*g711_enc_open)      (HANDLE handle);
extern bool   (*g711_enc_close)     (HANDLE handle);
extern int    (*g711_enc_encode)    (HANDLE handle, char* bit, int bitSize, char *pcm, int pcmSize);
extern int    (*g711_enc_get_option)(HANDLE handle, int option);
extern void   (*g711_enc_set_option)(HANDLE handle, int option, int value);

// ----------------------------------------------------------------------------
// g711_dec
// ----------------------------------------------------------------------------
extern HANDLE (*g711_dec_create)    ();
extern void   (*g711_dec_delete)    (HANDLE handle);
extern bool   (*g711_dec_open)      (HANDLE handle);
extern bool   (*g711_dec_close)     (HANDLE handle);
extern int    (*g711_dec_decode)    (HANDLE handle, char *pcm, int pcmSize, char* bit, int bitSize);
extern int    (*g711_dec_get_option)(HANDLE handle, int option);
extern void   (*g711_dec_set_option)(HANDLE handle, int option, int value);

// ----------------------------------------------------------------------------
// g723_enc
// ----------------------------------------------------------------------------
extern HANDLE (*g723_enc_create)    ();
extern void   (*g723_enc_delete)    (HANDLE handle);
extern bool   (*g723_enc_open)      (HANDLE handle);
extern bool   (*g723_enc_close)     (HANDLE handle);
extern int    (*g723_enc_encode)    (HANDLE handle, char* bit, int bitSize, char *pcm, int pcmSize);
extern int    (*g723_enc_get_option)(HANDLE handle, int option);
extern void   (*g723_enc_set_option)(HANDLE handle, int option, int value);

// ----------------------------------------------------------------------------
// g723_dec
// ----------------------------------------------------------------------------
extern HANDLE (*g723_dec_create)    ();
extern void   (*g723_dec_delete)    (HANDLE handle);
extern bool   (*g723_dec_open)      (HANDLE handle);
extern bool   (*g723_dec_close)     (HANDLE handle);
extern int    (*g723_dec_decode)    (HANDLE handle, char *pcm, int pcmSize, char* bit, int bitSize);
extern int    (*g723_dec_get_option)(HANDLE handle, int option);
extern void   (*g723_dec_set_option)(HANDLE handle, int option, int value);

// ----------------------------------------------------------------------------
// g729_enc
// ----------------------------------------------------------------------------
extern HANDLE (*g729_enc_create)    ();
extern void   (*g729_enc_delete)    (HANDLE handle);
extern bool   (*g729_enc_open)      (HANDLE handle);
extern bool   (*g729_enc_close)     (HANDLE handle);
extern int    (*g729_enc_encode)    (HANDLE handle, char* bit, int bitSize, char *pcm, int pcmSize);
extern int    (*g729_enc_get_option)(HANDLE handle, int option);
extern void   (*g729_enc_set_option)(HANDLE handle, int option, int value);

// ----------------------------------------------------------------------------
// g729_dec
// ----------------------------------------------------------------------------
extern HANDLE (*g729_dec_create)    ();
extern void   (*g729_dec_delete)    (HANDLE handle);
extern bool   (*g729_dec_open)      (HANDLE handle);
extern bool   (*g729_dec_close)     (HANDLE handle);
extern int    (*g729_dec_decode)    (HANDLE handle, char *pcm, int pcmSize, char* bit, int bitSize);
extern int    (*g729_dec_get_option)(HANDLE handle, int option);
extern void   (*g729_dec_set_option)(HANDLE handle, int option, int value);

// ----------------------------------------------------------------------------
// VSG72XDLL
// ----------------------------------------------------------------------------
class VSG72XDLL : public VDDLL
{
public:
  VSG72XDLL()          { fileName = "vdg72x.dll"; }
  virtual ~VSG72XDLL() {}
public:
  virtual bool load();
  virtual bool unload() { return true; }

public:
  static int        refCount;
  static VSG72XDLL* g_g72xDLL;
  static void classInitialize();    
  static void classFinalize();
};

#endif  __VSG72X_H__
