// ----------------------------------------------------------------------------
//
// VoIPSniffer version 2.0
//
// http://www.gilgil.net
//
// Copyright (c) NetworkLab Corporation All rights reserved
//
// ----------------------------------------------------------------------------

#ifndef __VSSESSION_H__
#define __VSSESSION_H__

#include "VDBuffer.h"
#include "VDRTP.h"

#include "SnoopIP.h"

#include "VSCommon.h"
#include "VSCodec.h"
#include "VSCodecG711.h"
#include "VSCodecG723.h"
#include "VSCodecG729.h"

// ----------------------------------------------------------------------------
// VSSession
// ----------------------------------------------------------------------------
class VSSession
{
public:
  VSCall* call; // reference

public:
  VSSession(VSCall* call);
  virtual ~VSSession();
  virtual bool open();
  virtual bool close();

public:
  VSAddr    srcMAddr;
  VSAddr    dstMAddr;
  DWORD     ssrc;

public:
  VSCodec*  codec;
  VDBuffer* bitBuffer;
  VDBuffer* pcmBuffer;

public:
  void processPayload(SnoopIPPacket* packet, char* payload, int payloadLen, bool* dataChanged);

public:
  virtual void processPCM(SnoopIPPacket* packet, char* pcm, int pcmLen, char* bit, int bitLen, bool* dataChanged) = 0;
};

// ----------------------------------------------------------------------------
// VSSessionList
// ----------------------------------------------------------------------------
class VSSessionList : public VDPList<VSSession*>
{
public:
  VSSessionList();
  virtual ~VSSessionList();
  virtual bool open();
  virtual bool close();

public:
  VSSession* find(VSAddr* srcMAddr, VSAddr* dstMAddr);
};

// ----------------------------------------------------------------------------
// VSSessionMgr
// ----------------------------------------------------------------------------
class VSSniff;
class VSSessionMgr : public VSSessionList
{
public:
  VSSessionMgr();
  virtual ~VSSessionMgr();

public:
  static bool process(
    VSSniff*       sniff,
    SnoopIPPacket* packet,
    VSAddr*        srcMAddr,
    VSAddr*        dstMAddr,
    char*          data,
    int            dataLen,
    bool*          dataChanged);
};

#endif  __VSSESSION_H__

