// ----------------------------------------------------------------------------
//
// VoIPSniffer version 2.0
//
// http://www.gilgil.net
//
// Copyright (c) NetworkLab Corporation All rights reserved
//
// ----------------------------------------------------------------------------

#ifndef __VOIPSNIFF_H__
#define __VOIPSNIFF_H__

#include "SnoopIP.h"
#include "SnoopTCP.h"
#include "SnoopUDP.h"
#include "SnoopCapturer.h"
#include "VSCommon.h"

// ----------------------------------------------------------------------------
// VSSniff
// ----------------------------------------------------------------------------
class VSSniff : public IVDXMLable
{
public:
  void* owner;
public:
  VSSniff(void* owner = NULL);
  virtual ~VSSniff();
  virtual bool open();
  virtual bool close();
  virtual void closeOldCall(DWORD tick);

public:
  VSCallList*      callList;

public:
  virtual void       process(SnoopCapturer* capturer, SnoopIPPacket* packet);
  virtual VSCall*    createNewCall() = 0;
  virtual VSSession* createNewSession(VSCall* call) = 0;

public:
  int minCallPacketCount;
  int closeOldCallInterval;

public:
  virtual void load(VDXML* xml);
  virtual void save(VDXML* xml);
};

#endif  __VOIPSNIFF_H__
