// ----------------------------------------------------------------------------
//
// VoIPSniffer version 2.0
//
// http://www.gilgil.net
//
// Copyright (c) NetworkLab Corporation All rights reserved
//
// ----------------------------------------------------------------------------

#ifndef __VSSNIFFGUI_H__
#define __VSSNIFFGUI_H__

#include "VDShowAudioData.h"
#include "VSSniffFile.h"
#include "FormVSCall.h"
#include "FrameVSSession.h"

// ----------------------------------------------------------------------------
// VSCallGUI
// ----------------------------------------------------------------------------
class VSSniffGUI;
class VSCallGUI : public VSCallFile
{
public:
  VSSniffGUI* sniffGUI;
public:
  TVSCallForm* callForm;
public:
  VSCallGUI(VSSniffGUI* sniffGUI);
  virtual ~VSCallGUI();
  virtual bool open();
  virtual bool close();
  virtual void changeCallInfo(string from, string to, VSAddr* fromAddr, VSAddr* toAddr);
  virtual void processPacket(SnoopIPPacket* packet);
};

// ----------------------------------------------------------------------------
// VSSessionGUI
// ----------------------------------------------------------------------------
class VSSessionGUI : public VSSessionFile
{
public:
  VSCallGUI* callGUI;
public:
  TVSSessionFrame* sessionFrame;
public:
  VSSessionGUI(VSCallGUI* callGUI);
  virtual ~VSSessionGUI();
  virtual bool open();
  virtual bool close();
public:
  virtual void processPCM(SnoopIPPacket* packet, char* pcm, int pcmLen, char* bit, int bitLen, bool* dataChanged);
};

// ----------------------------------------------------------------------------
// VSSniffGUI
// ----------------------------------------------------------------------------
class VSSniffGUI : public VSSniffFile
{
public:
  VSSniffGUI(void* owner = NULL);
  virtual ~VSSniffGUI();
public:
  TForm*  ownerForm;
  TPanel* showPanel;
public:
  bool showGraph;
public:
  virtual VSCall*    createNewCall();
  virtual VSSession* createNewSession(VSCall* call);
public:
  virtual void load(VDXML* xml);
  virtual void save(VDXML* xml);
};

#endif  __VSSNIFFGUI_H__
