//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "FormOption.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "FrameSnoopARPSpoof"
#pragma link "FrameSnoopNetInfo"
#pragma resource "*.dfm"
TOptionForm *OptionForm;
//---------------------------------------------------------------------------
void TOptionForm::initializeControl()
{
  pcOption->ActivePageIndex = 0;
}

void TOptionForm::finalizeControl()
{
}

void TOptionForm::loadControl()
{
  // SnoopARPSpoof
  global->loadSnoopARPSpoof(&global->arpSpoof);
  global->loadSnoopAdapter(&global->adapter);
  SnoopARPSpoofFrame1->loadControl(&global->arpSpoof);

  // SnoopNetInfo
  global->loadNetInfo(&global->netInfo);
  SnoopNetInfoFrame1->loadControl(&global->netInfo);

  // VSSniff
  global->loadVoIPSniff(&global->voipSniff);
  edMinCallPacketCount->Text = global->voipSniff.minCallPacketCount;
  edCloseOldCallInterval->Text = global->voipSniff.closeOldCallInterval;
  chkSaveWaveFile->Checked = global->voipSniff.saveWaveFile;
  edWaveFileFolder->Text = global->voipSniff.waveFileFolder.c_str();
  chkSaveCaptureFile->Checked = global->voipSniff.saveCaptureFile;
  edMentFileName->Text = global->voipSniff.mentFileName.c_str();
  chkInsertMent->Checked = global->voipSniff.insertMent;
  edCaptureFileFolder->Text = global->voipSniff.captureFileFolder.c_str();
  edJitterTime->Text = global->voipSniff.jitterTime;
  chkShowGraph->Checked = global->voipSniff.showGraph;
}

void TOptionForm::saveControl()
{
  // SnoopARPSpoof
  SnoopARPSpoofFrame1->saveControl(&global->arpSpoof);
  global->saveSnoopARPSpoof(&global->arpSpoof);
  global->saveSnoopAdapter(&global->adapter);

  // SnoopNetInfo
  SnoopNetInfoFrame1->saveControl(&global->netInfo);
  global->saveNetInfo(&global->netInfo);

  // VSSniff
  global->voipSniff.minCallPacketCount = StrToInt(edMinCallPacketCount->Text);
  global->voipSniff.closeOldCallInterval = StrToInt(edCloseOldCallInterval->Text);
  global->voipSniff.saveWaveFile = chkSaveWaveFile->Checked;
  global->voipSniff.waveFileFolder = edWaveFileFolder->Text.c_str();
  global->voipSniff.saveCaptureFile = chkSaveCaptureFile->Checked;
  global->voipSniff.captureFileFolder = edCaptureFileFolder->Text.c_str();
  global->voipSniff.insertMent = chkInsertMent->Checked;
  global->voipSniff.mentFileName = edMentFileName->Text.c_str();
  global->voipSniff.jitterTime = StrToInt(edJitterTime->Text);
  global->voipSniff.showGraph = chkShowGraph->Checked;
  global->saveVoIPSniff(&global->voipSniff);

  global->save();
}

void TOptionForm::setControl()
{
  edWaveFileFolder->Enabled = chkSaveWaveFile->Checked;
  sbtWaveFileFolder->Enabled = chkSaveWaveFile->Checked;
  edCaptureFileFolder->Enabled = chkSaveCaptureFile->Checked;
  sbtCaptureFileFolder-> Enabled = chkSaveCaptureFile->Checked;
  edMentFileName->Enabled = chkInsertMent->Checked;
  sbtMentFileName->Enabled = chkInsertMent->Checked;
}

//---------------------------------------------------------------------------
__fastcall TOptionForm::TOptionForm(TComponent* Owner)
  : TForm(Owner)
{
}
//---------------------------------------------------------------------------


void __fastcall TOptionForm::FormCreate(TObject *Sender)
{
  initializeControl();  
}
//---------------------------------------------------------------------------

void __fastcall TOptionForm::FormShow(TObject *Sender)
{
  loadControl();
  setControl();
}
//---------------------------------------------------------------------------

void __fastcall TOptionForm::FormClose(TObject *Sender, TCloseAction &Action)
{
//
}
//---------------------------------------------------------------------------

void __fastcall TOptionForm::FormDestroy(TObject *Sender)
{
  finalizeControl();
}
//---------------------------------------------------------------------------

void __fastcall TOptionForm::btnOkClick(TObject *Sender)
{
  saveControl();
  Close();  
}
//---------------------------------------------------------------------------

void __fastcall TOptionForm::btnCancelClick(TObject *Sender)
{
  Close();  
}
//---------------------------------------------------------------------------

void __fastcall TOptionForm::SnoopNetInfoFrame1btnAutoCheckClick(
      TObject *Sender)
{
  int adapterIndex = SnoopARPSpoofFrame1->SnoopFrame1->cbxAdapter->ItemIndex;
  SnoopNetInfoFrame1->detect(adapterIndex);
}
//---------------------------------------------------------------------------

void __fastcall TOptionForm::SnoopFrame1btnAutoCheckClick(TObject *Sender)
{
  SnoopARPSpoofFrame1->SnoopFrame1btnAutoCheckClick(Sender);
  global->adapterIndex = SnoopARPSpoofFrame1->SnoopFrame1->cbxAdapter->ItemIndex;
}
//---------------------------------------------------------------------------
void __fastcall TOptionForm::sbtCaptureFileFolderClick(TObject *Sender)
{
  AnsiString dir;
  dir = edCaptureFileFolder->Text;
  if (SelectDirectory("Select Capture File Folder", "", dir))
    edCaptureFileFolder->Text = dir + "\\";
}
//---------------------------------------------------------------------------

void __fastcall TOptionForm::sbtWaveFileFolderClick(TObject *Sender)
{
  AnsiString dir;
  dir = edWaveFileFolder->Text;
  if (SelectDirectory("Select Wave File Folder", "", dir))
    edWaveFileFolder->Text = dir + "\\";
}
//---------------------------------------------------------------------------

void __fastcall TOptionForm::ComboBoxClick(TObject *Sender)
{
  setControl();  
}
//---------------------------------------------------------------------------

void __fastcall TOptionForm::sbtMentFileNameClick(TObject *Sender)
{
  if (odMent->Execute())
  {
    edMentFileName->Text = odMent->FileName;
  } 
}
//---------------------------------------------------------------------------

