#ifndef __GLOBAL_H__
#define __GLOBAL_H__

#include "VDXMLFile.h"
#include "SnoopARPSpoof.h"
#include "SnoopAdapter.h"
#include "SnoopFile.h"
#include "SnoopIP.h"
#include "SnoopNetInfo.h"
#include "FrameSnoopSessionList.h"
#include "VSSniffGUI.h"

class Global
{
protected:
  VDXMLFile xmlFile;
public:
  Global();
  virtual ~Global();
  void load();
  void save();
  bool isOk();
public:
  // Log
  void initializeLog();
  void finalizeLog();

  // WindowPos
  bool loadWindowPos(HWND hwnd, char* name);
  bool saveWindowPos(HWND hwnd, char* name);

  __declspec(property (get=getAdapterIndex, put=setAdapterIndex)) int adapterIndex;
  int getAdapterIndex();
  void setAdapterIndex(int value);

  // SnoopARPSpoof
  SnoopARPSpoof arpSpoof;
  void loadSnoopARPSpoof(SnoopARPSpoof* arpSpoof);
  void saveSnoopARPSpoof(SnoopARPSpoof* arpSpoof);

  // SnoopAdapter
  SnoopAdapter adapter;
  void loadSnoopAdapter(SnoopAdapter* adapter);
  void saveSnoopAdapter(SnoopAdapter* adapter);

  // SnoopFile
  SnoopFile snoopFile;
  void loadSnoopFile(SnoopFile* snoopFile);
  void saveSnoopFile(SnoopFile* snoopFile);

  // SnoopNetInfo
  SnoopNetInfo netInfo;
  void loadNetInfo(SnoopNetInfo* netInfo);
  void saveNetInfo(SnoopNetInfo* netInfo);

  // SessionListFrame
  void loadSessionListFrame(TSnoopSessionListFrame* frame);
  void saveSessionListFrame(TSnoopSessionListFrame* frame);

  // VSSniff
  VSSniffGUI voipSniff;
  void loadVoIPSniff(VSSniff* voipSniff);
  void saveVoIPSniff(VSSniff* voipSniff);
           
  // Other
  bool relay;
  void loadOther();
  void saveOther();

public:
  bool isSameLanIP(IP ip);
};

extern Global* global;

#endif  __GLOBAL_H__
