//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "FormHost.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "FrameSnoopHostList"
#pragma link "FrameSnoopSessionList"
#pragma resource "*.dfm"
THostForm *HostForm;
//---------------------------------------------------------------------------
#include "FormMain.h"
//---------------------------------------------------------------------------
#define TAB_HEIGHT 20
void THostForm::initializeControl()
{
  BorderStyle = bsNone;

  SnoopSessionListFrame1->Align = alClient;
  SnoopSessionListFrame1->tsCustom->Visible = false;
  SnoopSessionListFrame1->cbxDirection->Visible = false;
  SnoopSessionListFrame1->pcSessionList->Align = alNone;
  SnoopSessionListFrame1->pcSessionList->TabHeight = TAB_HEIGHT;

  TSnoopHostListFrame* frame = SnoopSessionListFrame1->SnoopHostListFrame1;
  frame->Align = alClient;
  frame->lvHostList->ShowColumnHeaders = false;
  frame->lvHostList->Font->Color = clWhite;
  frame->lvHostList->Font->Size = 10;
  frame->lvHostList->Color = clBlack;
  frame->pnlBasicTop->Visible = false;
  frame->addSelf = false;


  for (int i = 0; i < frame->lvHostList->Columns->Count; i++)
  {
    TListColumn* ListColumn = frame->lvHostList->Columns->Items[i];
    ListColumn->Width = ListColumn->Width * 1.5;
  }
}

void THostForm::finalizeControl()
{
}

void THostForm::loadControl()
{
  // SessionListFrame
  global->loadSessionListFrame(SnoopSessionListFrame1);
  if (SnoopSessionListFrame1->SnoopHostListFrame1->lvHostList->Items->Count == 0)
    MainForm->ibtScan->Click();
}

void THostForm::saveControl()
{
  // SessionListFrame
  global->saveSessionListFrame(SnoopSessionListFrame1);
}

void THostForm::setControl()
{
  bool scanning = SnoopSessionListFrame1->SnoopHostListFrame1->active();
  MainForm->ibtScan->Enabled = !scanning;
  if (scanning)
  {
    pnlScanning->Visible = scanning;
    pnlScanning->Font->Color = clBlack;
    tmrBlink->Enabled = true;
  } else
  {
    pnlScanning->Visible = false;
    tmrBlink->Enabled = false;
  }
}

//---------------------------------------------------------------------------
__fastcall THostForm::THostForm(TComponent* Owner)
  : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall THostForm::FormCreate(TObject *Sender)
{
  initializeControl();
}
//---------------------------------------------------------------------------
void __fastcall THostForm::FormShow(TObject *Sender)
{
  loadControl();
  setControl();
}
//---------------------------------------------------------------------------
void __fastcall THostForm::FormClose(TObject *Sender, TCloseAction &Action)
{
  saveControl();
}
//---------------------------------------------------------------------------
void __fastcall THostForm::FormDestroy(TObject *Sender)
{
//  
}
//---------------------------------------------------------------------------

void __fastcall THostForm::SnoopHostListFrame1tmrCloseTimer(TObject *Sender)
{
  SnoopSessionListFrame1->SnoopHostListFrame1->tmrCloseTimer(Sender);
  setControl();  
}
//---------------------------------------------------------------------------

void __fastcall THostForm::FormResize(TObject *Sender)
{
  int borderSize =
    (SnoopSessionListFrame1->pcSessionList->Width -
    SnoopSessionListFrame1->SnoopHostListFrame1->lvHostList->Width) / 2 + 1;
  // ----- by gilgil 2009.02.26 -----
  /*
  LOG_DEBUG("[FormHost.cpp] THostForm::FormResize clientwidth=%d SnoopSessionListFrame1_width=%d borderSize=%d",
    ClientWidth, SnoopSessionListFrame1->Width, borderSize);
  */
  // --------------------------------

  SnoopSessionListFrame1->Width = ClientWidth;
  SnoopSessionListFrame1->Height = ClientHeight;
  TPageControl* pc = SnoopSessionListFrame1->pcSessionList;
  pc->Left = -borderSize;
  pc->Top = -(TAB_HEIGHT + 3) - borderSize;
  pc->Width = SnoopSessionListFrame1->Width + borderSize * 2 + 1;
  pc->Height = SnoopSessionListFrame1->Height - pc->Top + borderSize * 2;

  pnlScanning->Left = (ClientWidth - pnlScanning->Width) / 2;
  pnlScanning->Top = (ClientHeight - pnlScanning->Height) / 2;
}
//---------------------------------------------------------------------------

void __fastcall THostForm::tmrBlinkTimer(TObject *Sender)
{
  if (pnlScanning->Font->Color == clBlack)
    pnlScanning->Font->Color = clYellow;
  else
    pnlScanning->Font->Color = clBlack;
}
//---------------------------------------------------------------------------

