//---------------------------------------------------------------------------

#ifndef FormMainH
#define FormMainH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ExtCtrls.hpp>
#include <jpeg.hpp>
#include <Buttons.hpp>
#include "ImageButton.hpp"
//---------------------------------------------------------------------------
#include "GlobalBasic.h"
#define WM_MY_CLOSE (WM_USER + 10)
//---------------------------------------------------------------------------
typedef enum
{
  vssNone,
  vssAbout,
  vssQuiz,
  vssHost,
  vssSniff
} VSStep;

class TMainForm : public TForm
{
__published:	// IDE-managed Components
  TPanel *pnlTop;
  TImage *imgTop;
  TLabel *lblTitle;
  TPanel *pnlMain;
  TPanel *pnlBottom;
  TImage *imgBottom;
  TImageButton *ibtPrev;
  TImageButton *ibtNext;
  TImageButton *ibtScan;
  TImageButton *ibtClear;
  TImageButton *ibtStart;
  TImageButton *ibtStop;
  TSpeedButton *sbtOption;
  TImageButton *ibtRegister;
  void __fastcall FormCreate(TObject *Sender);
  void __fastcall FormShow(TObject *Sender);
  void __fastcall FormClose(TObject *Sender, TCloseAction &Action);
  void __fastcall FormDestroy(TObject *Sender);
  void __fastcall sbtOptionClick(TObject *Sender);
  void __fastcall ibtPrevClick(TObject *Sender);
  void __fastcall ibtNextClick(TObject *Sender);
  void __fastcall ibtScanClick(TObject *Sender);
  void __fastcall ibtClearClick(TObject *Sender);
  void __fastcall ibtStartClick(TObject *Sender);
  void __fastcall ibtStopClick(TObject *Sender);
  void __fastcall ibtRegisterClick(TObject *Sender);
private:	// User declarations
public:		// User declarations
  __fastcall TMainForm(TComponent* Owner);
public:
  virtual void __fastcall WndProc(TMessage &Message);
  void initializeControl();
  void finalizeControl();
  void loadControl();
  void saveControl();
  void setControl();
public:
  bool   quizResolved;
  VSStep step;
  void gotoStep(VSStep step);
public:
  static void _snoopCapturer_OnClose(void* sender);

  SnoopARPSpoof snoopARPSpoof;
  static void _snoopARPSpoof_OnCapture(
    SnoopARPSpoof*       snoopARPSpoof,
    SnoopARPSpoofPacket* packet);

  SnoopAdapter snoopAdapter;
  static void _snoopAdapter_OnCapture(
    SnoopCapturer* capturer,
    PKT_HDR*       pktHdr,
    char*          pktData);

  VSSniffGUI* sniff;

private:
  void __fastcall MyShow(TMessage &Msg);
  BEGIN_MESSAGE_MAP
    MESSAGE_HANDLER(WM_MYSHOW,TMessage, MyShow)
  END_MESSAGE_MAP(TForm)
};
//---------------------------------------------------------------------------
extern PACKAGE TMainForm *MainForm;
//---------------------------------------------------------------------------
#endif
