//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "FormRegister.h"
#include "FormMain.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TRegisterForm *RegisterForm;

//---------------------------------------------------------------------------
bool isRegisterResponseOK(string response, bool* res, bool* not_res)
{
  static string succeedEncodeStr = "016A9BDBD46DA5D700F822D428F195691D4CD709FE35B73A61E2008F9130017AF28E38"; // "Registration completed successfully"
  static string failEncodeStr = "016A9BDBD46DA5D700F822D428F49B6D0145D6"; // "Registration failed"
  static string okEncodeStr = "613FCC92E852"; // "200 OK"

  if (response == decodeHexToStr(okEncodeStr))
  {
    *res = true;
    Application->MessageBox(
      decodeHexToStr(succeedEncodeStr).c_str(),
      "Register",
      MB_OK);
    *not_res = false;
    return true;
  } else
  {
    *res = false;
    Application->MessageBox(
      decodeHexToStr(failEncodeStr).c_str(),
      "Register",
      MB_OK);
    *not_res = true;
    return false;
  }
}

//---------------------------------------------------------------------------
void TRegisterForm::setControl()
{
  btnRegister->Enabled = (edEmail->Text != "" && edKey->Text != "");
}
//---------------------------------------------------------------------------
__fastcall TRegisterForm::TRegisterForm(TComponent* Owner)
  : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TRegisterForm::FormCreate(TObject *Sender)
{
  Color = clWhite;
  edEmail->Text = "";
  edKey->Text = "";
}
//---------------------------------------------------------------------------
void __fastcall TRegisterForm::FormShow(TObject *Sender)
{
  setControl();
}
//---------------------------------------------------------------------------
void __fastcall TRegisterForm::FormClose(TObject *Sender, TCloseAction &Action)
{
//
}
//---------------------------------------------------------------------------
void __fastcall TRegisterForm::btnRegisterClick(TObject *Sender)
{
  string email = edEmail->Text.c_str();
  string key = edKey->Text.c_str();
  string url = g_gk->registerURL;
  LOG_DEBUG("%s", url.c_str());

  url = url + "?email=" + email + "&key=" + key;

  string response = getHTTP(url);
  bool res, not_res;
  if (isRegisterResponseOK(response, &res, &not_res))
  {
    if (res && !not_res)
    {
      g_reg->doRegister();
      MainForm->gotoStep(vssAbout);
     } else
     {
       LOG_ERROR("[FormRegister.cpp] *********************************************");
       LOG_ERROR("[FormRegister.cpp] TRegisterForm::btnRegisterClick hack detected");
       LOG_ERROR("[FormRegister.cpp] *********************************************");
     }
  }
  Close();
}
//---------------------------------------------------------------------------
void __fastcall TRegisterForm::EditChange(TObject *Sender)
{
  setControl();
}
//---------------------------------------------------------------------------

void __fastcall TRegisterForm::lblRegisterOnlineClick(TObject *Sender)
{
  string url = g_gk->registerOnlineURL;
  ShellExecute(0, "open", url.c_str(), NULL, NULL, SW_SHOW);
}
//---------------------------------------------------------------------------

