#include "GetHTTP.h"

// ----------------------------------------------------------------------------
// GetHTTP
// ----------------------------------------------------------------------------
GetHTTP::GetHTTP()
{
	internetSession = InternetOpen(NULL, INTERNET_OPEN_TYPE_PRECONFIG, NULL, NULL, 0);
	if (internetSession == NULL)
	{
		LOG_ERROR("[GetHTTP.cpp] GetHTTP::GetHTTP InternetOpen return NULL GetLastError==%d", GetLastError());
	}
  buffer = new VDBuffer;
  buffer->open();
}

GetHTTP::~GetHTTP()
{
	if (internetSession != NULL)
	{
		InternetCloseHandle(internetSession);
		internetSession = NULL;
	}
  buffer->close();
  SAFE_DELETE(buffer);
}

#define TEMP_BUFFER_SIZE 8192
int GetHTTP::get(const string url, char** buf)
{
	HINTERNET httpFile;
	char tempBuffer[TEMP_BUFFER_SIZE];
	DWORD byteRead;

	httpFile = InternetOpenUrl(internetSession, url.c_str(), NULL, 0, INTERNET_FLAG_NO_CACHE_WRITE, 0);
	if (httpFile == NULL)
	{
		LOG_DEBUG("[GetHTTP.cpp] InternetOpenUrl return NULL GetLastError==%d", GetLastError());
		goto _error;
	}
  buffer->clear();
	while (true)
	{
		if (!InternetReadFile(httpFile, tempBuffer, TEMP_BUFFER_SIZE, &byteRead))
		{
			LOG_DEBUG("[GetHTTP.cpp] InternetReadFile return false GetLastError==%d", GetLastError());
			goto _error;
		}
		if (byteRead == 0) break;
    buffer->write(tempBuffer, byteRead);
	}
  buffer->write("\0", 1);
	*buf = buffer->mem();

	InternetCloseHandle(httpFile);
	return buffer->len();
_error:
	if (httpFile != NULL)
		InternetCloseHandle(httpFile);
	return -1;
}

string GetHTTP::get(const string url)
{
  int    len;
  char*  buf;
  string res;

  len = get(url, &buf);
  if (len != -1)
  {
    res = buf;
	}
  return res;
}

// ----------------------------------------------------------------------------
// Function
// ----------------------------------------------------------------------------
string getHTTP(const string url)
{
  GetHTTP getHTTP;
  return getHTTP.get(url);
}
