#include "Register.h"

_Register *g_reg = NULL;

// ----------------------------------------------------------------------------
// _Register
// ----------------------------------------------------------------------------
int _Register::getWinIniValue()
{
  string encodeAppName = "0560B5E2F477BED012F43FF869E19367"; // "VoIPSnifferBasic"
  string encodeKeyName = "016A9BDBD46DB2C411F5"; // "Registered"

  int res = GetProfileInt(
    decodeHexToStr(encodeAppName).c_str(),
    decodeHexToStr(encodeKeyName).c_str(),
    0);
  return res;
}

int _Register::getRegistryValue()
{
  LONG res;
  HKEY hKey;

  res = RegOpenKeyEx(
    HKEY_CURRENT_USER,
    decodeHexToStr("00609AC6D078A5D328DF28CE7FFD886F2141D021CD3EDE1947EF0A8C8426154DFF912843").c_str(), // "Software\NetworkLab\VoIPSnifferBasic"
    0,
    KEY_ALL_ACCESS,
    &hKey);
  if (res != ERROR_SUCCESS)
  {
    LOG_DEBUG("[Register.cpp] _Register::getRegistryValue RegOpenKeyEx return %d(0x%x)", res, res);
    return 0;
  }

  DWORD value = 0;
  DWORD regType = REG_DWORD;
  DWORD valueSize = sizeof(value);
  res = RegQueryValueEx(
    hKey,
    decodeHexToStr("016A9BDBD46DB2C411F5").c_str(), // "Registered",
    NULL,
    &regType,
    (LPBYTE)&value,
    (LPDWORD)&valueSize);
  if (res != ERROR_SUCCESS)
  {
    LOG_ERROR("[Register.cpp] _Register::getRegistryValue RegQueryValueEx return %d(0x%x)", res, res);
    return 0;
  }

  return (int)value;
}

void _Register::setWinIniValue(int value)
{
  string s = format("%d", value);
  BOOL res = WriteProfileString(
    decodeHexToStr("0560B5E2F477BED012F43FF869E19367").c_str(), // "VoIPSnifferBasic"
    decodeHexToStr("016A9BDBD46DB2C411F5").c_str(),             // "Registered",
    s.c_str());
  if (!res)
  {
    LOG_ERROR("[Register.cpp] *********************************************************");
    LOG_ERROR("[Register.cpp] _Register::setWinIniValie WriteProfileString return false");
    LOG_ERROR("[Register.cpp] *********************************************************");
  }
}

void _Register::setRegistryValue(int value)
{
  LONG res;
  HKEY hKey;

  DWORD lpdwDisposition;
  res = RegCreateKeyEx(HKEY_CURRENT_USER,
    decodeHexToStr("00609AC6D078A5D328DF28CE7FFD886F2141D021CD3EDE1947EF0A8C8426154DFF912843").c_str(), // "Software\NetworkLab\VoIPSnifferBasic",
    0,
    NULL,
    REG_OPTION_NON_VOLATILE,
    KEY_ALL_ACCESS,
    NULL,
    &hKey,
    &lpdwDisposition);
  if (res != ERROR_SUCCESS)
  {
    LOG_ERROR("[Register.cpp] _Register::setRegistryValue RegCreateKeyEx return %d(0x%x)", res, res);
    return;
  }

  res = RegSetValueEx(
    hKey,
    "Registered",
    0,
    REG_DWORD,
    (const BYTE*)&value,
    sizeof(value));
  if (res != ERROR_SUCCESS)
  {
    LOG_ERROR("[Register.cpp] _Register::setRegistryValue RegSetValueEx return %d(0x%x)", res, res);
    return;
  }
  LOG_INFO("[Register.cpp] _Register::setRegistryValue completed successfully");
}

_Register::_Register()
{
  int winIniValue = getWinIniValue();
  int registryValue = getRegistryValue();
  registered = (winIniValue != 0) && (registryValue != 0);
  LOG_DEBUG("[Register.cpp] _Register::_Register registered=%d", (int)registered);
}

_Register::~_Register()
{
}

bool _Register::isRegistered()
{
  return registered;
}

bool _Register::isHacked()
{
  int winIniValue = getWinIniValue();
  int registryValue = getRegistryValue();

  //
  // Check win.ini and registry value
  //
  if ((winIniValue == 0 && registryValue != 0) ||
    (winIniValue != 0  && registryValue == 0))
  {
    LOG_DEBUG("[Register.cpp] _Register::isHacked registration value %d %d", winIniValue, registryValue);
    return true;
  }

  //
  // Check md4 file checksum
  //
  string md5_ment_wav = "C40F725CEA9D6CAE9747954D64C580C0";

  string s = getMD5HexChecksum(extractFilePath(VDApplication::exeName()) + "ment.wav");
  if (md5_ment_wav != s)
  {
    LOG_DEBUG("[Register.cpp] _Register::isHacked md5_ment_wav");
    return true;
  }

  string md5_ment_1042_wav = "B9C6640586A80DA2CD9B6BFC5B7C841D";
  s = getMD5HexChecksum(extractFilePath(VDApplication::exeName()) + "ment_1042.wav");
  if (md5_ment_1042_wav != s)
  {
    LOG_DEBUG("[Register.cpp] _Register::isHacked md5_ment_1042_wav");
    return true;
  }

  //
  // Check ment file name
  //
  VSSniffGUI voipSniff;
  global->loadVoIPSniff(&voipSniff);

  if (!voipSniff.insertMent)
  {
    LOG_DEBUG("[Register.cpp] _Register::isHacked insertMent is false");
    return true;
  }
  string mentFileName = extractFileName(voipSniff.mentFileName);
  if (mentFileName != decodeHexToStr("3E6A92C6896EB6C0")) // "ment.wav"
  {
    LOG_DEBUG("[Register.cpp] _Register::isHacked invalid ment file name(%s)", mentFileName.c_str());
    return true;
  }

  return false;
}

void _Register::doRegister()
{
  LOG_DEBUG("[Register.cpp] Register::doRegister");
  randomize();
  setWinIniValue(random(256) + 1);
  setRegistryValue(random(256) + 1);
  registered = true;
}
