//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop
//---------------------------------------------------------------------------
USEFORM("..\..\..\Snoop50\Src\Frame\FormSnoopSession.cpp", SnoopSessionForm);
USEFORM("..\..\..\Snoop50\Src\Frame\FrameSnoop.cpp", SnoopFrame); /* TFrame: File Type */
USEFORM("..\..\..\Snoop50\Src\Frame\FrameSnoopHostList.cpp", SnoopHostListFrame); /* TFrame: File Type */
USEFORM("..\..\..\Snoop50\Src\Frame\FrameSnoopNetInfo.cpp", SnoopNetInfoFrame); /* TFrame: File Type */
USEFORM("..\..\..\Snoop50\Src\Frame\FrameSnoopSessionList.cpp", SnoopSessionListFrame); /* TFrame: File Type */
USEFORM("..\..\..\Snoop50\Src\Frame\FrameSnoopARPSpoof.cpp", SnoopARPSpoofFrame); /* TFrame: File Type */
USEFORM("..\Common\FrameVSSession.cpp", VSSessionFrame); /* TFrame: File Type */
USEFORM("..\Common\FormVSCall.cpp", VSCallForm);
USEFORM("..\VoIPSniffer\FormOption.cpp", OptionForm);
USEFORM("FormAbout.cpp", AboutForm);
USEFORM("FormBasicOption.cpp", BasicOptionForm);
USEFORM("FormHack.cpp", HackForm);
USEFORM("FormHost.cpp", HostForm);
USEFORM("FormMain.cpp", MainForm);
USEFORM("FormQuiz.cpp", QuizForm);
USEFORM("FormRegister.cpp", RegisterForm);
USEFORM("FormSniff.cpp", SniffForm);
//---------------------------------------------------------------------------
#include "VDDelphi.h" // for VDApplication gilgil temp 2009.03.23
#include "FormBasicOption.h"
#include "FormHack.h"
#include "GlobalBasic.h"
#include "Register.h"
//---------------------------------------------------------------------------

void initialize()
{
  global = new GlobalBasic;
  global->initializeLog();
  LOG_INFO("");
#ifdef _DEBUG
  LOG_INFO("[VoIPSnifferBasic.cpp] VoIPSnifferBasic DEBUG   %s %s", __TIME__, __DATE__);
#else  _DEBUG
  LOG_INFO("[VoIPSnifferBasic.cpp] VoIPSnifferBasic RELEASE %s %s", __TIME__, __DATE__);
#endif _DEBUG
  g_gk = new GateKeeper;
  g_reg = new _Register;
}

void finalize()
{
  SAFE_DELETE(g_reg);
  SAFE_DELETE(g_gk);
  SAFE_DELETE(global);
}

WINAPI WinMain(HINSTANCE, HINSTANCE, LPSTR, int)
{
  HANDLE justOneHandle = NULL;
  SetLastError(0);
  justOneHandle = CreateMutex(NULL, false, "VoIP Sniffer Basic");
  DWORD error = GetLastError();
  if (error == ERROR_ALREADY_EXISTS || error == ERROR_ACCESS_DENIED)
  {
    HANDLE handle = FindWindow("TMainForm", "VoIP Sniffer Basic");
    if (handle != NULL) SendMessage(handle, WM_MYSHOW, 0, 0);
    return 0; 
  }

  try
  {
     Application->Initialize();
     SetApplicationMainFormOnTaskBar(Application, false);
     Application->Title = "VoIP Sniffer Basic";
     Application->CreateForm(__classid(TMainForm), &MainForm);
     initialize();
     application->setWorkFolder(extractFilePath(application->exeName()));
     if (g_reg->isHacked())
     {
        HackForm = new THackForm(Application);
        HackForm->ShowModal();
        finalize();
        return -1;
     }
     ((GlobalBasic*)global)->loadGateKeeper(g_gk);
     if (!g_gk->load(((GlobalBasic*)global)->gkURL))
     {
       if (!g_reg->isRegistered())
       {
         string msg = format("Can not load gatekeeper information( %s )", ((GlobalBasic*)global)->gkURL.c_str());
         Application->MessageBox(msg.c_str(), "Error", MB_ICONERROR);
         finalize();
         return 0;
       }
     }
     if (!global->isOk())
     {
       BasicOptionForm = new TBasicOptionForm(Application);
       BasicOptionForm->ShowModal();
     }
     Application->Run();
     global->finalizeLog();
     finalize();
  }
  catch (Exception &exception)
  {
     Application->ShowException(&exception);
  }
  catch (...)
  {
     try
     {
       throw Exception("");
     }
     catch (Exception &exception)
     {
       Application->ShowException(&exception);
     }
  }

  if (justOneHandle != NULL)
  {
    CloseHandle(justOneHandle);
    justOneHandle = NULL;
  }
  
  return 0;
}
//---------------------------------------------------------------------------
