//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "DataModule.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "IBCustomDataSet"
#pragma link "IBDatabase"
#pragma link "IBTable"
#pragma link "IBQuery"
#pragma resource "*.dfm"
TDM *DM;
//---------------------------------------------------------------------------
void TDM::refreshTable(TIBTable* table)
{
  if (!table->Transaction->InTransaction)
    table->Transaction->StartTransaction();
  table->Transaction->Commit();
  table->Close();
  table->Open();
}
//---------------------------------------------------------------------------
__fastcall TDM::TDM(TComponent* Owner)
  : TDataModule(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TDM::DataModuleCreate(TObject *Sender)
{
  //
  // Open DB
  //
  dbVoIPSniffer->Close();
  dbVoIPSniffer->DatabaseName = global->databaseName.c_str();
  dbVoIPSniffer->Params->Text = global->params.c_str();
  try {
    dbVoIPSniffer->Open();
  } catch (...) {
    LOG_FATAL("Can not open database");
  }

  //
  // Open Table
  //
  try {
    tbCall->Open();
  } catch (...) {
    LOG_FATAL("Can not open table Call");
  }
  try {
    tbPhone->Open();
  } catch (...) {
    LOG_FATAL("Can not open table Phone");
  }

  //
  // Close Query
  //
  qrQuery->Close();

}
//---------------------------------------------------------------------------
void __fastcall TDM::DataModuleDestroy(TObject *Sender)
{
  // Close DB, Table, Query
  dbVoIPSniffer->Close();
  tbCall->Close();
  tbPhone->Close();
  qrQuery->Close();
}
//---------------------------------------------------------------------------
