//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "FormMain.h"
#include "FormOption.h"
#include "FormCall.h"
#include "FormPhone.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TMainForm *MainForm;
//---------------------------------------------------------------------------
void __fastcall TMainForm::WndProc(TMessage &Message)
{
  switch (Message.Msg)
  {
    case WM_MY_CLOSE:
      myClose();
      break;
    default:
      TForm::WndProc(Message);
  }
}
void TMainForm::initializeControl()
{
  Color = clWhite;
  isCloseApplication = false;
  main = new _Main;
  DM = new TDM(Application);
}

void TMainForm::finalizeControl()
{
  SAFE_DELETE(main);
  // SAFE_DELETE(DM); DM is deleted automatically
}

void TMainForm::loadControl()
{
  // WindowPos
  if (!global->loadWindowPos(Handle, "MainForm"))
  {
    Left = 0;
    Top = 0;
  }
}

void TMainForm::saveControl()
{
  // WindowPos
  global->saveWindowPos(Handle, "MainForm");
}

void TMainForm::setControl()
{
  bool active = main->active();

  miOpen->Enabled = !active;
  btnOpen->Enabled = !active;

  miClose->Enabled = active;
  btnClose->Enabled = active;
}

void TMainForm::myClose()
{
  miClose->Click();  
}
//---------------------------------------------------------------------------
__fastcall TMainForm::TMainForm(TComponent* Owner)
  : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::FormCreate(TObject *Sender)
{
  initializeControl();
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::FormShow(TObject *Sender)
{
  loadControl();
  setControl();
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::FormCloseQuery(TObject *Sender, bool &CanClose)
{
  if (!isCloseApplication)
  {
    CanClose = false;
    saveControl();
    Hide();
  }  
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::FormClose(TObject *Sender, TCloseAction &Action)
{
  saveControl();
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::FormDestroy(TObject *Sender)
{
  finalizeControl();
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::FormResize(TObject *Sender)
{
  imgLogo->Left = (ClientWidth - imgLogo->Width) / 2;
  imgLogo->Top = (ClientHeight - imgLogo->Height + pnlTop->Height - StatusBar1->Height) / 2;  
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::TrayIcon1DblClick(TObject *Sender)
{
  loadControl();
  Show();
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::miShowClick(TObject *Sender)
{
  loadControl();
  Show();
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::miExitClick(TObject *Sender)
{
  isCloseApplication = true;
  Close();
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::miOpenClick(TObject *Sender)
{
  main->open();
  setControl();  
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::miCloseClick(TObject *Sender)
{
  main->close();
  setControl();  
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::miOptionClick(TObject *Sender)
{
  if (OptionForm == NULL) OptionForm = new TOptionForm(Application);
  OptionForm->ShowModal();
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::miCallClick(TObject *Sender)
{
  if (CallForm == NULL) CallForm = new TCallForm(Application);
  DM->refreshTable(DM->tbCall);
  CallForm->Show();
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::miPhoneClick(TObject *Sender)
{
  if (PhoneForm == NULL) PhoneForm = new TPhoneForm(Application);
  DM->refreshTable(DM->tbPhone);
  PhoneForm->Show();
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::btnOpenClick(TObject *Sender)
{
  miOpen->Click();  
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::btnCloseClick(TObject *Sender)
{
  miClose->Click();  
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::btnOptionClick(TObject *Sender)
{
  miOption->Click();
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::btnCallClick(TObject *Sender)
{
  miCall->Click();  
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::btnPhoneClick(TObject *Sender)
{
  miPhone->Click();  
}
//---------------------------------------------------------------------------

