//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop
//---------------------------------------------------------------------------
USEFORM("FormMain.cpp", MainForm);
USEFORM("FormOption.cpp", OptionForm);
USEFORM("DataModule.cpp", DM); /* TDataModule: File Type */
USEFORM("..\..\..\Snoop50\Src\Frame\FormSnoopSession.cpp", SnoopSessionForm);
USEFORM("..\..\..\Snoop50\Src\Frame\FrameSnoop.cpp", SnoopFrame); /* TFrame: File Type */
USEFORM("..\..\..\Snoop50\Src\Frame\FrameSnoopARPSpoof.cpp", SnoopARPSpoofFrame); /* TFrame: File Type */
USEFORM("..\..\..\Snoop50\Src\Frame\FrameSnoopHostList.cpp", SnoopHostListFrame); /* TFrame: File Type */
USEFORM("..\..\..\Snoop50\Src\Frame\FrameSnoopNetInfo.cpp", SnoopNetInfoFrame); /* TFrame: File Type */
USEFORM("..\..\..\Snoop50\Src\Frame\FrameSnoopSessionList.cpp", SnoopSessionListFrame); /* TFrame: File Type */
USEFORM("FormCall.cpp", CallForm);
USEFORM("FormPhone.cpp", PhoneForm);
//---------------------------------------------------------------------------
#include "FormOption.h"
#include "Global.h"
//---------------------------------------------------------------------------
WINAPI WinMain(HINSTANCE, HINSTANCE, LPSTR, int)
{
  HANDLE mutex = CreateMutex(NULL, true, "VoIPSnifferSvcEnt.exe");
  if (mutex == 0 || GetLastError() == ERROR_ALREADY_EXISTS)
  {
    ShowMessage("VoIPSnifferSvcMgr.exe already launched");
    goto _end;
  }
  try
  {
     Application->Initialize();
     SetApplicationMainFormOnTaskBar(Application, false);
     Application->Title = "VoIP Sniffer Enterprise";
     global = new Global;
#ifdef _DEBUG
     LOG_INFO("[VoIPSnifferSvcMgr.cpp] VoIPSnifferEnt DEBUG   %s %s", __TIME__, __DATE__);
#else  _DEBUG
     LOG_INFO("[VoIPSnifferSvcMgr.cpp] VoIPSnifferEnt RELEASE %s %s", __TIME__, __DATE__);
#endif _DEBUG
     if (!global->isOk())
     {
       OptionForm = new TOptionForm(Application);
       OptionForm->ShowModal();
     }
     Application->CreateForm(__classid(TMainForm), &MainForm);
     Application->Run();
     delete global;
  }
  catch (Exception &exception)
  {
     Application->ShowException(&exception);
  }
  catch (...)
  {
     try
     {
       throw Exception("");
     }
     catch (Exception &exception)
     {
       Application->ShowException(&exception);
     }
  }
  _end:
  if (mutex != 0) CloseHandle(mutex);
  return 0;
}
//---------------------------------------------------------------------------
