#ifndef __GLOBAL_H__
#define __GLOBAL_H__

#include "VDXMLFile.h"
#include "SnoopAdapter.h"
#include "SnoopNetInfo.h"
#include "VSSniffDB.h"

#ifdef SNOOP_THREAD_SAFE_SUPPORT
#warning SNOOP_THREAD_SAFE_SUPPORT must be turned off(see SnoopConfig.h)
#endif SNOOP_THREAD_SAFE_SUPPORT

class Global
{
public:
  VDXMLFile xmlFile;
public:
  Global();
  virtual ~Global();
  void load();
  void save();
  bool isOk();
public:
  // Log
  void initializeLog();
  void finalizeLog();

  // WindowPos
  bool loadWindowPos(HWND hwnd, char* name);
  bool saveWindowPos(HWND hwnd, char* name);

  __declspec(property (get=getAdapterIndex, put=setAdapterIndex)) int adapterIndex;
  int getAdapterIndex();
  void setAdapterIndex(int value);

  // SnoopCapturer
  SnoopCapturer* capturer;
  void loadSnoopCapturer(SnoopCapturer* capturer);
  void saveSnoopCapturer(SnoopCapturer* capturer);

  // SnoopAdapter
  SnoopAdapter adapter;
  void loadSnoopAdapter(SnoopAdapter* adapter);
  void saveSnoopAdapter(SnoopAdapter* adapter);

  // SnoopNetInfo
  SnoopNetInfo netInfo;
  void loadNetInfo(SnoopNetInfo* netInfo);
  void saveNetInfo(SnoopNetInfo* netInfo);

  // VSSniff
  VSSniffDB voipSniff;
  void loadVoIPSniff(VSSniff* voipSniff);
  void saveVoIPSniff(VSSniff* voipSniff);

  // DB
  string databaseName;
  string params;
  void loadDB();
  void saveDB();
};

extern Global* global;

#endif  __GLOBAL_H__

