//---------------------------------------------------------------------------
#include "SvcMain.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"

#include "SnoopIP.h"
#include "SnoopTCP.h"
#include "SnoopUDP.h"
#include "SnoopCapturer.h"
#include "VSCommon.h"
//---------------------------------------------------------------------------
TVoIPSniffer *VoIPSniffer;
//---------------------------------------------------------------------------
__fastcall TVoIPSniffer::TVoIPSniffer(TComponent* Owner)
	: TService(Owner)
{
}

TServiceController __fastcall TVoIPSniffer::GetServiceController(void)
{
	return (TServiceController) ServiceController;
}

void __stdcall ServiceController(unsigned CtrlCode)
{
	VoIPSniffer->Controller(CtrlCode);
}

//---------------------------------------------------------------------------
void TVoIPSniffer::stop()
{
  this->DoStop();
}
//---------------------------------------------------------------------------
void __fastcall TVoIPSniffer::ServiceAfterInstall(TService *Sender)
{
  LOG_TRACE("[SvcMain.cpp] TVoIPSniffer::ServiceAfterInstall");
}
//---------------------------------------------------------------------------

void __fastcall TVoIPSniffer::ServiceAfterUninstall(TService *Sender)
{
  LOG_TRACE("[SvcMain.cpp] TVoIPSniffer::ServiceAfterUninstall");
}
//---------------------------------------------------------------------------

void __fastcall TVoIPSniffer::ServiceBeforeInstall(TService *Sender)
{
  LOG_TRACE("[SvcMain.cpp] TVoIPSniffer::ServiceBeforeInstall");
}
//---------------------------------------------------------------------------

void __fastcall TVoIPSniffer::ServiceBeforeUninstall(TService *Sender)
{
  LOG_TRACE("[SvcMain.cpp] TVoIPSniffer::ServiceBeforeUninstall");
}
//---------------------------------------------------------------------------

void __fastcall TVoIPSniffer::ServiceContinue(TService *Sender, bool &Continued)
{
  LOG_TRACE("[SvcMain.cpp] TVoIPSniffer::ServiceContinue");
}
//---------------------------------------------------------------------------

void __fastcall TVoIPSniffer::ServiceCreate(TObject *Sender)
{
  LOG_TRACE("[SvcMain.cpp] TVoIPSniffer::ServiceCreate");
}
//---------------------------------------------------------------------------

void __fastcall TVoIPSniffer::ServiceDestroy(TObject *Sender)
{
  LOG_TRACE("[SvcMain.cpp] TVoIPSniffer::ServiceDestroy");
}
//---------------------------------------------------------------------------

void __fastcall TVoIPSniffer::ServiceExecute(TService *Sender)
{
  LOG_TRACE("[SvcMain.cpp] TVoIPSniffer::ServiceExecute beg");
  if (main == NULL)
  {
    LOG_ERROR("[SvcMain.cpp] TVoIPSniffer::ServiceExecute main is NULL");
    goto _end;    
  }
  if (!main->active())
  {
    LOG_ERROR("[SvcMain.cpp] TVoIPSniffer::ServiceExecute main is not active");
    goto _end;                   
  }
  ServiceThread->ProcessRequests(true);
_end:
  LOG_TRACE("[SvcMain.cpp] TVoIPSniffer::ServiceExecute end");
}
//---------------------------------------------------------------------------

void __fastcall TVoIPSniffer::ServicePause(TService *Sender, bool &Paused)
{
  LOG_TRACE("[SvcMain.cpp] TVoIPSniffer::ServicePause");
}
//---------------------------------------------------------------------------

void __fastcall TVoIPSniffer::ServiceShutdown(TService *Sender)
{
  LOG_TRACE("[SvcMain.cpp] TVoIPSniffer::ServiceShutdown");
  SAFE_DELETE(main);
  SAFE_DELETE(DataModule1);
}
//---------------------------------------------------------------------------

void __fastcall TVoIPSniffer::ServiceStart(TService *Sender, bool &Started)
{
  LOG_TRACE("[SvcMain.cpp] TVoIPSniffer::ServiceStart");

  if (DataModule1 == NULL) DataModule1 = new TDataModule1(NULL);
  if (!DataModule1->dbVoIPSniffer->Connected) goto _error;

  if (main == NULL) main = new _Main;
  if (main->open())
  {
    LOG_TRACE("[SvcMain.cpp] TVoIPSniffer::ServiceStart service started successfully");
  } else
  {
    LOG_ERROR("[SvcMain.cpp] TVoIPSniffer::ServiceStart service started failed");
    goto _error;
  }
  return;
_error:
  SAFE_DELETE(main);
  SAFE_DELETE(DataModule1);  
}
//---------------------------------------------------------------------------

void __fastcall TVoIPSniffer::ServiceStop(TService *Sender, bool &Stopped)
{
  LOG_TRACE("[SvcMain.cpp] TVoIPSniffer::ServiceStop");
  SAFE_DELETE(main);
  SAFE_DELETE(DataModule1);
}
//---------------------------------------------------------------------------

