#include <SysUtils.hpp>
#include <SvcMgr.hpp>
#pragma hdrstop
#include "Global.h"
#define Application Svcmgr::Application
USEFORM("SvcMain.cpp", VoIPSniffer); /* TService: File Type */
USEFORM("DataModule.cpp", DataModule1); /* TDataModule: File Type */

//---------------------------------------------------------------------------
WINAPI WinMain(HINSTANCE, HINSTANCE, LPSTR, int)
{
	try
	{
		// Windows 2003 Server requires StartServiceCtrlDispatcher to be
		// called before CoRegisterClassObject, which can be called indirectly
		// by Application.Initialize. TServiceApplication->DelayInitialize allows
		// Application->Initialize to be called from TService->Main (after
		// StartServiceCtrlDispatcher has been called).
		//
		// Delayed initialization of the Application object may affect
		// events which then occur prior to initialization, such as
		// TService->OnCreate. It is only recommended if the ServiceApplication
		// registers a class object with OLE and is intended for use with
		// Windows 2003 Server.
		//
		// Application->DelayInitialize = true;
		//
    global = new Global;
    LOG_TRACE("");
#ifdef _DEBUG
    LOG_TRACE("[VoIPSnifferSvc.cpp] VoIPSnifferSvc DEBUG   %s %s", __TIME__, __DATE__);
#else  _DEBUG
    LOG_TRACE("[VoIPSnifferSvc.cpp] VoIPSnifferSvc RELEASE %s %s", __TIME__, __DATE__);
#endif _DEBUG

		if ((!Application->DelayInitialize) || (Application->Installing()))
		{
			Application->Initialize();
		}
		Application->Title = "VoIPSnifferSvc";
    Application->CreateForm(__classid(TVoIPSniffer), &VoIPSniffer);
    Application->Run();
    LOG_TRACE("[VoIPSnifferSvc.cpp] VoIPSnifferSvc end");
    delete global;
	}
	catch (Exception &exception)
	{
		Sysutils::ShowException(&exception, System::ExceptAddr());
	}
  catch(...)
  {
		try
		{
      throw Exception("");
		}
		catch(Exception &exception)
		{
			Sysutils::ShowException(&exception, System::ExceptAddr());
		}
  }
  return 0;
}  
