//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "FormMain.h"
#include "FormOutput.h"
#include "FormOption.h"
#include "FormCall.h"
#include "FormPhone.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TMainForm *MainForm;
//---------------------------------------------------------------------------
void TMainForm::initializeControl()
{
  Color = clWhite;
  isCloseApplication = false;  
}

void TMainForm::finalizeControl()
{
}

void TMainForm::loadControl()
{
  // WindowPos
  if (!global->loadWindowPos(Handle, "MainForm"))
  {
    Left = 0;
    Top = 0;
  }
}

void TMainForm::saveControl()
{
  // WindowPos
  global->saveWindowPos(Handle, "MainForm");
}

void TMainForm::setControl()
{
}

void __fastcall TMainForm::OnNewLine(System::TObject* Sender, AnsiString NewLine, TOutputType OutputType)
{
  OutputForm->mmOutput->Lines->Add(NewLine);
}
//---------------------------------------------------------------------------
__fastcall TMainForm::TMainForm(TComponent* Owner)
  : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::FormCreate(TObject *Sender)
{
  initializeControl();
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::FormShow(TObject *Sender)
{
  loadControl();
  setControl();
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::FormCloseQuery(TObject *Sender, bool &CanClose)
{
  if (!isCloseApplication)
  {
    CanClose = false;
    saveControl();
    Hide();
  }
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::FormClose(TObject *Sender, TCloseAction &Action)
{
  saveControl();
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::FormDestroy(TObject *Sender)
{
  finalizeControl();
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::FormResize(TObject *Sender)
{
  imgLogo->Left = (ClientWidth - imgLogo->Width) / 2;
  imgLogo->Top = (ClientHeight - imgLogo->Height + pnlTop->Height - StatusBar1->Height) / 2;
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::TrayIcon1DblClick(TObject *Sender)
{
  Show();
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::miShowClick(TObject *Sender)
{
  loadControl();
  Show();
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::miExitClick(TObject *Sender)
{
  isCloseApplication = true;
  Close();
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::miCloseClick(TObject *Sender)
{
  Close();  
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::miCommandClick(TObject *Sender)
{
  AnsiString command = ((TMenuItem*)Sender)->Hint;
  if (command == "") return;

  if (OutputForm == NULL) OutputForm = new TOutputForm(Application);
  OutputForm->Show();

  OutputForm->mmOutput->Lines->Add("");
  OutputForm->mmOutput->Lines->Add("");
  OutputForm->mmOutput->Lines->Add("---------- Start Command : " + command + " ----------");

  TDosCommand* dosCommand = new TDosCommand(NULL);
  dosCommand->CommandLine = command;
  dosCommand->OnNewLine = OnNewLine;
  dosCommand->Execute();
  while (true)
  {
    if (dosCommand->ThreadStatus == dtsSuccess) break;
    Sleep(1);
    Application->ProcessMessages();
  }

  OutputForm->mmOutput->Lines->Add("---------- Stop  Command : " + command + " ----------");

  delete dosCommand;
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::miOptionClick(TObject *Sender)
{
  if (OptionForm == NULL) OptionForm = new TOptionForm(Application);
  OptionForm->ShowModal();
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::miCallClick(TObject *Sender)
{
  if (CallForm == NULL) CallForm = new TCallForm(Application);
  DataModule1->refreshTable(DataModule1->tbCall);
  CallForm->Show();
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::miPHoneClick(TObject *Sender)
{
  if (PhoneForm == NULL) PhoneForm = new TPhoneForm(Application);
  DataModule1->refreshTable(DataModule1->tbPhone);
  PhoneForm->Show();
}
//---------------------------------------------------------------------------

