//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop
//---------------------------------------------------------------------------
USEFORM("..\..\..\Snoop50\Src\Frame\FormSnoopSession.cpp", SnoopSessionForm);
USEFORM("..\..\..\Snoop50\Src\Frame\FrameSnoop.cpp", SnoopFrame); /* TFrame: File Type */
USEFORM("..\..\..\Snoop50\Src\Frame\FrameSnoopARPSpoof.cpp", SnoopARPSpoofFrame); /* TFrame: File Type */
USEFORM("..\..\..\Snoop50\Src\Frame\FrameSnoopHostList.cpp", SnoopHostListFrame); /* TFrame: File Type */
USEFORM("..\..\..\Snoop50\Src\Frame\FrameSnoopNetInfo.cpp", SnoopNetInfoFrame); /* TFrame: File Type */
USEFORM("..\..\..\Snoop50\Src\Frame\FrameSnoopSessionList.cpp", SnoopSessionListFrame); /* TFrame: File Type */
USEFORM("..\VoIPSnifferSvc\DataModule.cpp", DataModule1); /* TDataModule: File Type */
USEFORM("FormMain.cpp", MainForm);
USEFORM("FormOption.cpp", OptionForm);
USEFORM("FormCall.cpp", CallForm);
USEFORM("FormPhone.cpp", PhoneForm);
USEFORM("FormOutput.cpp", OutputForm);
//---------------------------------------------------------------------------
#include "FormOption.h"
#include "GlobalMgr.h"
//---------------------------------------------------------------------------
WINAPI WinMain(HINSTANCE, HINSTANCE, LPSTR, int)
{
  HANDLE mutex = CreateMutex(NULL, true, "VoIPSnifferSvcMgr.exe");
  if (mutex == 0 || GetLastError() == ERROR_ALREADY_EXISTS)
  {
    ShowMessage("VoIPSnifferSvcMgr.exe already launched");
    goto _end;
  }
  try
  {
     Application->Initialize();
     SetApplicationMainFormOnTaskBar(Application, false);
     Application->Title = "VoIP Sniffer Service Manager";
     Application->CreateForm(__classid(TMainForm), &MainForm);
     global = (Global*)new GlobalMgr;
#ifdef _DEBUG
     LOG_INFO("[VoIPSnifferSvcMgr.cpp] VoIPSnifferSvcMgr DEBUG   %s %s", __TIME__, __DATE__);
#else  _DEBUG
     LOG_INFO("[VoIPSnifferSvcMgr.cpp] VoIPSnifferSvcMgr RELEASE %s %s", __TIME__, __DATE__);
#endif _DEBUG
     if (!global->isOk())
     {
       OptionForm = new TOptionForm(Application);
       OptionForm->ShowModal();
     }
     Application->Run();
     delete global;
  }
  catch (Exception &exception)
  {
     Application->ShowException(&exception);
  }
  catch (...)
  {
     try
     {
       throw Exception("");
     }
     catch (Exception &exception)
     {
       Application->ShowException(&exception);
     }
  }
_end:
  if (mutex != 0) CloseHandle(mutex);
  return 0;
}
//---------------------------------------------------------------------------
